/*----- PROTECTED REGION ID(CanberraAIM556StateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        CanberraAIM556StateMachine.cpp
//
// description : State machine file for the CanberraAIM556 class
//
// project :     MCA Canberra AIM 556
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <CanberraAIM556.h>

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::CanberraAIM556StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  Acquistion is running
//  OFF      |  Acquisition is stopped
//  UNKNOWN  |  Communication failure


namespace CanberraAIM556_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_ADC_allowed()
 *	Description : Execution allowed for ADC attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_ADC_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::ON)
		{
		/*----- PROTECTED REGION ID(CanberraAIM556::ADCStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ADCStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for ADC attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::ADCStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ADCStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_Mode_allowed()
 *	Description : Execution allowed for Mode attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_Mode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::ON)
		{
		/*----- PROTECTED REGION ID(CanberraAIM556::ModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ModeStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Mode attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::ModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_Channels_allowed()
 *	Description : Execution allowed for Channels attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_Channels_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::ON)
		{
		/*----- PROTECTED REGION ID(CanberraAIM556::ChannelsStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ChannelsStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Channels attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::ChannelsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ChannelsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_PresetLiveTime_allowed()
 *	Description : Execution allowed for PresetLiveTime attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_PresetLiveTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PresetLiveTime attribute in Write access.
	/*----- PROTECTED REGION ID(CanberraAIM556::PresetLiveTimeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::PresetLiveTimeStateAllowed_WRITE

	//	Not any excluded states for PresetLiveTime attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::PresetLiveTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::PresetLiveTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_PresetRealTime_allowed()
 *	Description : Execution allowed for PresetRealTime attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_PresetRealTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PresetRealTime attribute in Write access.
	/*----- PROTECTED REGION ID(CanberraAIM556::PresetRealTimeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::PresetRealTimeStateAllowed_WRITE

	//	Not any excluded states for PresetRealTime attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::PresetRealTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::PresetRealTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_LiveTime_allowed()
 *	Description : Execution allowed for LiveTime attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_LiveTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LiveTime attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::LiveTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::LiveTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_RealTime_allowed()
 *	Description : Execution allowed for RealTime attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_RealTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for RealTime attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::RealTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::RealTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_Data_allowed()
 *	Description : Execution allowed for Data attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_Data_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Data attribute in read access.
	/*----- PROTECTED REGION ID(CanberraAIM556::DataStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::DataStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_On_allowed()
 *	Description : Execution allowed for On attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for On command.
	/*----- PROTECTED REGION ID(CanberraAIM556::OnStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::OnStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_Off_allowed()
 *	Description : Execution allowed for Off attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_Off_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Off command.
	/*----- PROTECTED REGION ID(CanberraAIM556::OffStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::OffStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_Reset_allowed()
 *	Description : Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON)
	{
	/*----- PROTECTED REGION ID(CanberraAIM556::ResetStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ResetStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556::is_ClearMemory_allowed()
 *	Description : Execution allowed for ClearMemory attribute
 */
//--------------------------------------------------------
bool CanberraAIM556::is_ClearMemory_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ClearMemory command.
	/*----- PROTECTED REGION ID(CanberraAIM556::ClearMemoryStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::ClearMemoryStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(CanberraAIM556::CanberraAIM556StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::CanberraAIM556StateAllowed.AdditionalMethods

}	//	End of namespace
